"""
Example pytest program for lab01, supplementary end of Lecture 7
and review for MP2's pytest component.
See corresponding pytest_demo/lab01.py for notes, along with #lec07
Discord demo screenshots.

Running pytest is similar to what you've done with
pycodestyle in lab already

$ pycodestyle lab01.py
(or)
$ python3 -m pycodestyle lab01.py

$ pytest test_lab01.py
(or)
$ python3 -m pytest test_lab01.py

Common errors students have at first:
- Forgetting to install pytest (similar to installing pycodestyle)
- Running python3 <test_program> instead of pytest <test_program>
- Running pytest <program> instead of pytest <test_program>
- Having files in the wrong locations 
    (e.g. test_mastermind.py should be in same directory as mp2_mastermind.py)

We run pytest on a program created with test_ functions
each representing a test function for asserting expected
values (you'll see red if the test function fails)

pytest is a command (after installing it) that
will know to execute all test_ functions in the
program name after it (e.g. test_lab01)
and test_lab01.py imports the functions its testing
(which is why if __name__ == '__main__' is important
in lab01/mp2_mastermind; it isn't executed if its
a program that is being imported, so that we can have
a testing program like test_mp2 only import functions,
and not execute the main code)

In mp2_mastermind, the run_game() at the end is only
executed if you run python3 mp2_mastermind.py, but
not if you run pytest test_mp2.py
"""

from lab01 import *

def test_user_to_email():
    # Empty username case (should result in '')
    assert user_to_email('') == ''
    # standard case, not handling case-sensitivity
    assert user_to_email('hovik') == 'hovik@caltech.edu'
    # standard case, handling case-sensitivity
    # function is expected to lowercase username in email
    assert user_to_email('HoVik') == 'hovik@caltech.edu'
    # case if there are numbers in username (just in case
    # the student has a hack with letters that breaks)
    assert user_to_email('h0v1k012') == 'h0v1k012@caltech.edu'


# The more test_ functions we add, the more will be ran
# in pytest test_lab01
# Your task: Add a few assert statements to test
# untested requirements in MP2
def test_other_lab01_fn():
    # assert ...
    assert False  # Placeholder


# Note: In practice we don't actually have any of the below in pytest
# programs (usually) but this is kept to supplement the review on
# modules and flow of execution when running imports (see screenshots
# from Discord and notes in pytest_demo/lab01)
if __name__ == '__main__':
    print('Currently in test_lab01.py (in __main__ condition)')
